import java.io.*;
import java.util.*;

public class strings_av {

	FastScanner in;
	PrintWriter out;

	final int MAX = 100;
	final int MOD = (int) (1e9 + 7);
	int[][] choose = new int[MAX + 1][MAX + 1];

	void precalc() {
		for (int i = 0; i <= MAX; i++) {
			choose[i][0] = 1;
			for (int j = 1; j <= i; j++) {
				choose[i][j] = choose[i - 1][j - 1] + choose[i - 1][j];
				if (choose[i][j] >= MOD) {
					choose[i][j] -= MOD;
				}
			}
		}
	}

	void solve() {
		int T = in.nextInt();
		precalc();
		for (int test = 0; test < T; test++) {
			int n = in.nextInt(), k = in.nextInt();
			String s = in.nextToken();
			int[] count = new int[2];
			for (char c : s.toCharArray()) {
				count[c - '0']++;
			}
			
			int ans = 0;
			for (int zeros = count[0]; zeros >= 0; zeros -= 2) {
				for (int ones = count[1]; ones >= 0; ones -= 3) {
					if (zeros + ones == k) {
						ans = (ans + choose[k][zeros]) % MOD;
					}
				}
			}
			out.println(ans);
		}
	}

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String nextToken() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(nextToken());
		}

		long nextLong() {
			return Long.parseLong(nextToken());
		}

		double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new strings_av().run();
	}
}
