import java.io.*;
import java.util.*;

public class teams_bm {
	FastScanner in;
	PrintWriter out;

	// 20:41
	// 20:57

	class Edge {
		int to;
		boolean sameTeam;

		public Edge(int to, boolean sameTeam) {
			super();
			this.to = to;
			this.sameTeam = sameTeam;
		}
	}

	ArrayList<Edge>[] g;

	void go(int v, int curTeam, boolean[] was, int[] inTeam) {
		if (inTeam[v] != 0 && inTeam[v] != curTeam)
			return;
		inTeam[v] = curTeam;
		was[v] = true;
		for (Edge e : g[v]) {
			if (was[e.to]) {
				continue;
			}
			go(e.to, e.sameTeam ? curTeam : 3 - curTeam, was, inTeam);
		}
	}

	class O {
		ArrayList<Integer>[] ids;
		int diff;

		O() {
			ids = new ArrayList[2];
			for (int i = 0; i < 2; i++) {
				ids[i] = new ArrayList<>();
			}
		}
	}

	void go2(int v, int curTeam, boolean[] was, int[] inTeam, O o) {
		if (inTeam[v] != 0 && inTeam[v] != curTeam)
			return;
		inTeam[v] = curTeam;
		o.ids[curTeam - 1].add(v);
		was[v] = true;
		for (Edge e : g[v]) {
			if (was[e.to]) {
				continue;
			}
			go2(e.to, e.sameTeam ? curTeam : 3 - curTeam, was, inTeam, o);
		}
	}

	void solve() {
		int tc = in.nextInt();
		for (int t = 0; t < tc; t++) {
			int n = in.nextInt();
			int m = in.nextInt();
			int[] inTeam = new int[n];
			g = new ArrayList[n];
			for (int i = 0; i < n; i++) {
				inTeam[i] = in.nextInt();
				g[i] = new ArrayList<>();
			}
			for (int i = 0; i < m; i++) {
				int fr = in.nextInt() - 1;
				int to = in.nextInt() - 1;
				boolean sameTeam = in.nextInt() == 0;
				g[fr].add(new Edge(to, sameTeam));
				g[to].add(new Edge(fr, sameTeam));
			}
			boolean[] was = new boolean[n];
			for (int i = 0; i < n; i++) {
				if (was[i] || inTeam[i] == 0) {
					continue;
				}
				go(i, inTeam[i], was, inTeam);
			}
			ArrayList<O> allO = new ArrayList<>();
			for (int i = 0; i < n; i++) {
				if (was[i]) {
					continue;
				}
				O o = new O();
				allO.add(o);
				go2(i, 1, was, inTeam, o);
			}
			int curCnt = 0;
			for (int i = 0; i < n; i++) {
				if (inTeam[i] == 1) {
					curCnt++;
				}
			}
			for (O o : allO) {
				o.diff = -o.ids[0].size() + o.ids[1].size();
			}
			byte[][] from = new byte[allO.size() + 1][n + 1];
			for (int i = 0; i <= allO.size(); i++) {
				Arrays.fill(from[i], (byte) -1);
			}
			from[0][curCnt] = 0;
			for (int layer = 0; layer < allO.size(); layer++) {
				for (int cur = 0; cur <= n; cur++) {
					if (from[layer][cur] == -1) {
						continue;
					}
					for (byte use = 0; use < 2; use++) {
						int newOne = cur + use * allO.get(layer).diff;
						from[layer + 1][newOne] = use;
					}
				}
			}
			if (n % 2 != 0) {
				out.println("NO");
				continue;
			}
			int need = n / 2;
			if (from[from.length - 1][need] == -1) {
				out.println("NO");
				continue;
			}
			for (int layer = from.length - 1; layer > 0; layer--) {
				if (from[layer][need] == 1) {
					O o = allO.get(layer - 1);
					need -= o.diff;
					for (ArrayList<Integer> ids : o.ids) {
						for (int id : ids) {
							inTeam[id] = 3 - inTeam[id];
						}
					}
				}
			}
			boolean fail = false;
			for (int i = 0; i < n; i++) {
				for (Edge e : g[i]) {
					if (e.sameTeam != (inTeam[i] == inTeam[e.to])) {
						out.println("NO");
						fail = true;
						break;
					}
				}
				if (fail)
					break;
			}
			int cnt = 0;
			for (int i = 0; i < n; i++) {
				if (inTeam[i] == 1)
					cnt++;
				else
					cnt--;
			}
			if (cnt != 0)
				fail = true;
			if (fail)
				continue;
			out.println("YES");
			for (int i = 0; i < n; i++) {
				out.print(inTeam[i]);
				if (i == n - 1) {
					out.println();
				} else {
					out.print(" ");
				}
			}
		}
	}

	void run() {
		try {
			in = new FastScanner(new File("teams.in"));
			out = new PrintWriter(new File("teams.out"));

			solve();

			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	void runIO() {

		in = new FastScanner(System.in);
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public FastScanner(InputStream f) {
			br = new BufferedReader(new InputStreamReader(f));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return null;
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		}

		boolean hasMoreTokens() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new teams_bm().runIO();
	}
}