#include <bits/stdc++.h>

class Edge {
private: 
    int to;
    int type;
public:    
    Edge(int to, int type) {
        this->to = to;
        this->type = type;
    }

    int getTo() {
        return to;
    }

    int getType() {
        return type;
    }
};

int q[200010];

int main() {
    int testsCount;
    scanf("%d", &testsCount);
    while (testsCount--) {
        int n, m;
        scanf("%d%d", &n, &m);
        std::vector<int> initialColors(n);
        for (int i = 0; i < n; i++) {
            scanf("%d", &initialColors[i]);
        }
        std::vector<std::vector<Edge>> graph(n);
        for (int i = 0; i < m; i++) {
            int v, u, type;
            scanf("%d%d%d", &v, &u, &type);
            --v, --u;
            graph[v].push_back(Edge(u, type));
            graph[u].push_back(Edge(v, type));
        }
        if (n & 1) {
            printf("NO\n");
            continue;
        }

        std::vector<std::vector<int>> vs[2];
        std::vector<bool> colorKnown;
        std::vector<bool> used(n, false);
        std::vector<int> color(n, 0);
        std::vector<int> empty;
        bool fail = false;
        for (int i = 0; i < n; i++) {
            if (used[i]) {
                continue;
            }
            vs[0].push_back(empty);
            vs[1].push_back(empty);
            colorKnown.push_back(false);
            int head = 0, tail = 0;
            q[tail++] = i;
            color[i] = 1;
            bool needToSwap = false;
            bool wasEqual = false;
            while (head != tail) {
                int v = q[head++];
                if (used[v] != 0) {
                    continue;
                }
                used[v] = true;
                vs[color[v] - 1].back().push_back(v);
                if (initialColors[v] != 0) {
                    colorKnown.back() = true;
                    if (initialColors[v] != color[v]) {
                        if (wasEqual) {
                            fail = true;
                        }
                        needToSwap = true;
                    } else {
                        if (needToSwap) {
                            fail = true;
                        }
                        wasEqual = true;
                    }
                }
                for (Edge &u : graph[v]) {
                    int needColor = color[v];
                    if (u.getType() == 1) {
                        needColor = (color[v] == 1 ? 2 : 1);
                    }
                    if (color[u.getTo()] == 0) {
                        q[tail++] = u.getTo();
                        color[u.getTo()] = needColor;
                    } else {
                        if (color[u.getTo()] != needColor) {
                            fail = true;
                        }                
                    }
                }
            }
            if (colorKnown.back()) {
                if (needToSwap) {
                    vs[0].back().swap(vs[1].back());
                }
            }
        }
        /*for (size_t i = 0; i < vs[0][0].size(); i++) {
            std::cerr << vs[0][0][i] << ' ';
        }
        std::cerr << '\n';
        for (size_t i = 0; i < vs[1][0].size(); i++) {
            std::cerr << vs[1][0][i] << ' ';
        }
        std::cerr << '\n';*/
        if (fail) {
            printf("NO\n");
            continue;
        }
        
        size_t components = vs[0].size();
        std::vector<std::vector<bool>> can(components + 1, std::vector<bool>(n + 1));
        std::vector<std::vector<int>> previous(components + 1, std::vector<int>(n + 1, -1));
        can[0][0] = true;
        for (size_t i = 0; i < components; i++) {
            for (int j = 0; j <= n; j++) {
                if (!can[i][j]) continue;
                if (j + (int)vs[0][i].size() <= n) {
                    can[i + 1][j + vs[0][i].size()] = true;
                    previous[i + 1][j + vs[0][i].size()] = j;
                }
                if (colorKnown[i]) {
                    continue;
                }
                if (j + (int)vs[1][i].size() <= n) {
                    can[i + 1][j + vs[1][i].size()] = true;
                    previous[i + 1][j + vs[1][i].size()] = j;
                }
            }
        }
        if (!can[components][n / 2]) {
            printf("NO\n");
            continue;
        }
        printf("YES\n");
        int nowi = components;
        int nowj = n / 2;
        std::vector<int> firstGroup;
        while (previous[nowi][nowj] != -1) {
            std::vector<int> &newPeople = vs[0][nowi - 1];
            if (!colorKnown[nowi - 1] && previous[nowi][nowj] == nowj - (int)vs[1][nowi - 1].size()) {
                newPeople = vs[1][nowi - 1];
            }
            for (size_t it = 0; it < newPeople.size(); it++) {
                firstGroup.push_back(newPeople[it]);                
            }

            nowj = previous[nowi][nowj];
            --nowi;
        }
        std::vector<int> ans(n, 2);
        for (size_t i = 0; i < firstGroup.size(); i++) {
            ans[firstGroup[i]] = 1;
        }
        for (int i = 0; i < n; i++) {
            printf("%d%c", ans[i], " \n"[i == n - 1]);
        }
    }
    return 0;
}

