import java.io.*;
import java.util.*;

public class map_bm_wa {
	FastScanner in;
	PrintWriter out;

	class Point implements Comparable<Point> {
		int x, y;

		public Point(int x, int y) {
			super();
			this.x = x;
			this.y = y;
		}

		@Override
		public String toString() {
			return "Point [x=" + x + ", y=" + y + "]";
		}

		@Override
		public int compareTo(Point o) {
			if (y == o.y) {
				return Integer.compare(x, o.x);
			}
			return Integer.compare(y, o.y);
		}

	}

	int ne(int x) {
		return x + 1 == n ? 0 : x + 1;
	}

	int pr(int x) {
		return x == 0 ? n - 1 : x - 1;
	}

	int n;

	class Segment {
		Point a, b;

		public Segment(Point a, Point b) {
			super();
			this.a = a;
			this.b = b;
		}

		@Override
		public String toString() {
			return "Segment [a=" + a + ", b=" + b + "]";
		}

	}

	class O {
		int x1, x2, sz;

		public O(int x1, int x2, int sz) {
			super();
			this.x1 = x1;
			this.x2 = x2;
			this.sz = sz;
		}

		long getSize(int pos) {
			if (pos <= x1 || pos >= x2) {
				return (x2 - x1) * 1L * sz;
			}
			return Math.max(x2 - pos, pos - x1) * 1L * sz;
		}
	}

	void solve() {
		n = in.nextInt();
		Point[] a = new Point[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Point(in.nextInt(), in.nextInt());
		}
		int minId = 0, maxId = 0;
		for (int i = 0; i < n; i++) {
			if (a[i].compareTo(a[minId]) <= 0) {
				minId = i;
			}
			if (a[i].compareTo(a[maxId]) >= 0) {
				maxId = i;
			}
		}
		ArrayList<Segment> left = new ArrayList<>();
		ArrayList<Segment> right = new ArrayList<>();
		for (int i = minId; i != maxId; i = ne(i)) {
			if (a[i].x == a[ne(i)].x) {
				left.add(new Segment(a[i], a[ne(i)]));
			}
		}
		for (int i = minId; i != maxId; i = pr(i)) {
			if (a[i].x == a[pr(i)].x) {
				right.add(new Segment(a[i], a[pr(i)]));
			}
		}
		int itLeft = 0, itRight = 0;
		ArrayList<O> o = new ArrayList<>();
		while (itLeft < left.size()) {
			int leftY = left.get(itLeft).b.y;
			int rightY = right.get(itRight).b.y;
			o.add(new O(left.get(itLeft).a.x, right.get(itRight).a.x, Math.min(
					left.get(itLeft).b.y, right.get(itRight).b.y)
					- Math.max(left.get(itLeft).a.y, right.get(itRight).a.y)));
			if (leftY == rightY) {
				itLeft++;
				itRight++;
			} else {
				if (leftY > rightY) {
					itRight++;
				} else {
					itLeft++;
				}
			}
		}
		int minX = Integer.MAX_VALUE, maxX = 0;
		for (Point p : a) {
			minX = Math.min(minX, p.x);
			maxX = Math.max(maxX, p.x);
		}
		final int IT = 10;
		long result = Long.MAX_VALUE;
		long LEFT = minX, RIGHT = maxX;
		final int C = 4;
		for (int it = 0; it < IT; it++) {
			minX = (int) (LEFT + (RIGHT- LEFT) * 1L * it / IT);
			maxX = (int) (LEFT + (RIGHT - LEFT) * 1L * (it + 1) / IT);
			while (maxX - minX > C) {
				int mid1 = (minX * 2 + maxX) / 3;
				int mid2 = (minX + maxX * 2) / 3;
				long ans1 = getAnswer(o, mid1);
				long ans2 = getAnswer(o, mid2);
				if (ans1 < ans2) {
					maxX = mid2;
				} else {
					minX = mid1;
				}
			}
			for (int x = minX; x <= maxX; x++) {
				result = Math.min(result, getAnswer(o, x));
			}
		}
		out.println(result);
	}

	long getAnswer(ArrayList<O> all, int pos) {
		long res = 0;
		for (O o : all) {
			res += o.getSize(pos);
		}
		return res;
	}

	void run() {
		try {
			in = new FastScanner(new File("map.in"));
			out = new PrintWriter(new File("map.out"));

			solve();

			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	void runIO() {

		in = new FastScanner(System.in);
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public FastScanner(InputStream f) {
			br = new BufferedReader(new InputStreamReader(f));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return null;
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		}

		boolean hasMoreTokens() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new map_bm_wa().runIO();
	}
}