import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;

/**
 * Created by Aksenov239 on 07.06.2015.
 */
public class map_va {
    public static void main(String[] args) {
        new map_va().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens())
            in = new StringTokenizer(br.readLine());
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public class Point {
        int x, y;

        public Point(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }

    public class Event implements Comparable<Event> {
        int x, dx;

        public Event(int x, int dx) {
            this.x = x;
            this.dx = dx;
        }

        public int compareTo(Event e) {
            return x == e.x ? Integer.compare(e.dx, dx) : Integer.compare(x, e.x);
        }
    }

    public void solve() throws IOException {
        int n = nextInt();

        Point[] points = new Point[n];

        int sr = 0;
        int sl = 0;
        for (int i = 0; i < n; i++) {
            points[i] = new Point(nextInt(), nextInt());
            if (points[i].y > points[sr].y || (points[i].y == points[sr].y && points[i].x > points[sr].x)) {
                sr = i;
            }

            if (points[i].y < points[sl].y || (points[i].y == points[sl].y && points[i].x < points[sl].x)) {
                sl = i;
            }
        }

        Point[] lp = new Point[sl > sr ? sr + n - sl : sr - sl];
        Point[] rp = new Point[sr > sl ? sl + n - sr : sl - sr];

        int l = 0;
        for (int i = sl; i != sr; i = (i + 1) % points.length) {
            lp[l++] = points[i];
        }

        int r = rp.length - 1;
        for (int i = sr; i != sl; i = (i + 1) % points.length) {
            rp[r--] = points[i];
        }

        ArrayList<Event> e = new ArrayList<Event>();
        l = 0;
        r = 0;
        int y = lp[0].y;
        long start = 0;
        while (l < lp.length || r < rp.length) {
            int yd = Math.min(lp[l + 1].y, rp[r + 1].y);
            int h = yd - y;

            start += 1L * h * (rp[r].x - lp[l].x);

            if ((rp[r].x - lp[l].x) % 2 == 0) {
                e.add(new Event(lp[l].x, -h));
                e.add(new Event((rp[r].x + lp[l].x) / 2, 2 * h));
                e.add(new Event(rp[r].x, -h));
            } else {
                e.add(new Event(lp[l].x, -h));
                e.add(new Event((rp[r].x + lp[l].x) / 2, h));
                e.add(new Event((rp[r].x + lp[l].x + 1) / 2, h));
                e.add(new Event(rp[r].x, -h));
            }

            if (lp[l + 1].y == yd) {
                l += 2;
            }
            if (rp[r + 1].y == yd) {
                r += 2;
            }
            y = yd;
        }

        Collections.sort(e);

        int x = e.get(0).x;
        long dx = 0;
        long min = Long.MAX_VALUE;
        for (Event event : e) {
            start += dx * (event.x - x);
            min = Math.min(start, min);
            dx += event.dx;
            x = event.x;
        }

        out.println(min);
    }//

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
