import java.io.*;
import java.util.*;

public class cartesian_av {

	FastScanner in;
	PrintWriter out;

	class SegmentTree {
		int[] pos, values;
		int size;

		public SegmentTree(int[] array) {
			this.values = array.clone();
			this.size = array.length;
			this.pos = new int[4 * size];
			build(0, size, 0);
		}

		void build(int left, int right, int i) {
			if (left + 1 == right) {
				pos[i] = left;
				return;
			}
			int mid = (left + right) >>> 1;
			build(left, mid, 2 * i + 1);
			build(mid, right, 2 * i + 2);
			pos[i] = selectMax(pos[2 * i + 1], pos[2 * i + 2]);
		}

		int selectMax(int first, int second) {
			if (first == -1) {
				return second;
			}
			if (second == -1) {
				return first;
			}
			return values[first] >= values[second] ? first : second;
		}

		int getMax(int left, int right) {
			return internalGet(0, size, left, right, 0);
		}

		int internalGet(int left, int right, int l, int r, int i) {
			if (l <= left && right <= r) {
				return pos[i];
			}
			if (right <= l || r <= left) {
				return -1;
			}
			int mid = (left + right) >>> 1;
			int ansLeft = internalGet(left, mid, l, r, i * 2 + 1);
			int ansRight = internalGet(mid, right, l, r, i * 2 + 2);
			return selectMax(ansLeft, ansRight);
		}
	}

	final int MOD = (int) (1e9 + 7);

	int inv(int a) {
		int b = MOD - 2;
		int result = 1;
		while (b > 0) {
			if ((b & 1) == 1) {
				result = (int) (1L * result * a % MOD);
			}
			a = (int) (1L * a * a % MOD);
			b >>>= 1;
		}
		return result;
	}

	int catalan(int n) {
		long num = 1, denom = 1;
		for (int i = 2; i <= n; i++) {
			num = num * (n + i) % MOD;
			denom = denom * i % MOD;
		}
		int result = (int) (num * inv((int) denom) % MOD);
		System.err.println(n + " " + result);
		return result;
	}

	int calculate(int l, int r, SegmentTree st) {
//		System.err.println(l + " " + r);
		if (l >= r) {
			return 1;
		}
		int result = 1;
		int maxValue = st.values[st.getMax(l, r)];
		int last = l, cnt = 0;
		while (last < r) {
			int max = st.getMax(last, r);
			if (st.values[max] == maxValue) {
				result = (int) (1L * result * calculate(last, max, st) % MOD);
				last = max + 1;
				cnt++;
			} else {
				result = (int) (1L * result * calculate(last, r, st) % MOD);
				break;
			}
		}
		return (int) (1L * result * catalan(cnt) % MOD);
	}

	void solve() {
		int n = in.nextInt();
		int[] ys = new int[n];
		for (int i = 0; i < n; i++) {
			ys[i] = in.nextInt();
		}
		SegmentTree st = new SegmentTree(ys);
		out.println(calculate(0, n, st));
	}

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		int T = in.nextInt();
		while (T-- > 0) {
			solve();
		}
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String nextToken() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(nextToken());
		}

		long nextLong() {
			return Long.parseLong(nextToken());
		}

		double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new cartesian_av().run();
	}
}
