import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class cartesian_bm {
	FastScanner in;
	PrintWriter out;

	// 21:36
	// 21:51

	final int mod = (int) 1e9 + 7;
	final int MAX = 4 * (int) 1e5 + 10;
	final int[] fact = new int[MAX];
	final int[] factInv = new int[MAX];

	void prec() {
		fact[0] = factInv[0] = 1;
		BigInteger modBI = BigInteger.valueOf(mod);
		for (int i = 1; i < MAX; i++) {
			fact[i] = (int) (fact[i - 1] * 1L * i % mod);
			factInv[i] = BigInteger.valueOf(fact[i]).modInverse(modBI)
					.intValue();
		}
	}

	int getCatalan(int n) {
		return (int) (fact[2 * n] * 1L * factInv[n] % mod * 1L * factInv[n + 1] % mod);
	}

	class O implements Comparable<O> {
		int pos;
		int value;

		public O(int pos, int value) {
			super();
			this.pos = pos;
			this.value = value;
		}

		@Override
		public int compareTo(O o) {
			if (value == o.value) {
				return Integer.compare(pos, o.pos);
			}
			return -Integer.compare(value, o.value);
		}

	}

	class Fenw {
		int[] s;
		int n;

		Fenw(int n) {
			this.n = n;
			s = new int[n];
		}

		int get(int x) {
			int res = 0;
			for (; x >= 0; x = (x & (x + 1)) - 1) {
				res += s[x];
			}
			return res;
		}

		void upd(int x, int y) {
			for (; x < n; x = x | (x + 1)) {
				s[x] += y;
			}
		}
	}

	void solve() {
		int tc = in.nextInt();
		prec();
		for (int t = 0; t < tc; t++) {
			int n = in.nextInt();
			O[] a = new O[n];
			for (int i = 0; i < n; i++) {
				a[i] = new O(i, in.nextInt());
			}
			Arrays.sort(a);
			int result = 1;
			Fenw fenw = new Fenw(n);
			for (int i = 0; i < n;) {
				int j = i;
				int cur = fenw.get(a[i].pos);
				while (j != n && a[i].value == a[j].value
						&& fenw.get(a[j].pos) == cur) {
					j++;
				}
				result = (int) (result * 1L * getCatalan(j - i) % mod);
				while (i != j) {
					fenw.upd(a[i].pos, 1);
					i++;
				}
			}
			out.println(result);
		}
	}

	void run() {
		try {
			in = new FastScanner(new File("object.in"));
			out = new PrintWriter(new File("object.out"));

			solve();

			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	void runIO() {

		in = new FastScanner(System.in);
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public FastScanner(InputStream f) {
			br = new BufferedReader(new InputStreamReader(f));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return null;
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		}

		boolean hasMoreTokens() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new cartesian_bm().runIO();
	}
}