#include <memory.h>
#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const int MAXN = 1 << 18;
const int MOD = 1000 * 1000 * 1000 + 7;

int n;
int a[MAXN];

bool reading() {
    if (scanf("%d", &n) != 1) return 0;
    for (int i = 0; i < n; i++) scanf("%d", &a[i]);
    return 1;
}

int bin(int n, int k) {
    int res = 1;
    while (k) {
        if (k & 1) res = 1LL * res * n % MOD;
        n = 1LL * n * n % MOD;
        k >>= 1;
    }
    return res;
}

int inv(int x) {
    return bin(x, MOD - 2);
}

int c[MAXN];
int fct[MAXN * 2];

int getC(int x) {
    if (c[x] == -1) {
        c[x] = fct[2 * x] * 1LL * inv(fct[x] * 1LL * fct[x] % MOD * (x + 1) % MOD) % MOD;
    }
    return c[x];
}

int fastsolve() {
    int ans = 1;
    fct[0] = 1;
    for (int i = 0; i < n * 2; i++) fct[i + 1] = 1LL * fct[i] * (i + 1) % MOD;

    vector<int> vct;
    vct.push_back(MOD + 2);
    a[n] = MOD + 1;
    for (int i = 0; i <= n; i++) {
        while (vct.back() < a[i]) {
            int cnt = 0, x = vct.back();
            while (vct.back() == x) {
                cnt++;
                vct.pop_back();
            }
            ans = 1LL * ans * getC(cnt) % MOD;
        }
        vct.push_back(a[i]);
    }
    return ans;
}

int main() {
    //freopen("cartesian.in", "r", stdin);
    //freopen("cartesian.out", "w", stdout);
    memset(c, -1, sizeof(c));

    int T;
    scanf("%d", &T);
    while (T--) {
        reading();
        printf("%d\n", fastsolve());
    }

 return 0;
}