import java.io.*;
import java.util.*;

public class cartesian_iz_ok1 {
    static final int MOD = 1_000_000_007;

    Scanner in;
    PrintWriter out;

    int bin(int n, int k) {
        if (k == 0) {
            return 1 % MOD;
        }
        int res = bin(n, k / 2);
        res = (int)((long)res * res % MOD);
        if (k % 2 == 1) {
            res = (int)((long)res * n % MOD);
        }
        return res;
    }

    int inv(int x) {
        return bin(x, MOD - 2);
    }

    void solve() {
        int n = in.nextInt();
        int a[] = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        
        int c[] = new int[n + 1];
        c[0] = 1;
        for (int i = 0; i < n; i++) {
            c[i + 1] = (int)((long)2 * c[i] * (2 * i + 1) % MOD * inv(i + 2) % MOD);
        }

        Integer p[] = new Integer[n];
        for (int i = 0; i < n; i++) {
            p[i] = i;
        }
        Arrays.sort(p, (i, j) -> {
            if (a[i] != a[j]) {
                return -Integer.compare(a[i], a[j]);
            }
            return -Integer.compare(i, j);
        });

        NavigableSet<Integer> set = new TreeSet<>();
        set.add(n);

        int ans = 1;
        for (int l = 0; l < n;) {
            int r = l;
            while (r < n && a[p[r]] == a[p[l]]) {
                r++;
            }

            int last = n;
            int cur = 0;
            for (int i = l; i < r; i++) {
                int clast = set.ceiling(p[i]);
                if (clast != last) {
                    ans = (int)((long)ans * c[cur] % MOD);
                    cur = 0;
                }
                cur++;
                last = clast;
            }
            ans = (int)((long)ans * c[cur] % MOD);
            for (int i = l; i < r; i++) {
                set.add(p[i]);
            }

            l = r;
        }
        out.println(ans);
    }

    public void run() {
        in = new Scanner(System.in);
        out = new PrintWriter(System.out);

        int T = in.nextInt();
        while (T --> 0) {
            solve();
        }
        out.close();
    }

    public static void main(String[] args) {
        new cartesian_iz_ok1().run();
    }
}

class Scanner {
    BufferedReader br;
    StringTokenizer st;

    Scanner(File f) {
        try {
            br = new BufferedReader(new FileReader(f));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    Scanner(InputStream stream) {
        br = new BufferedReader(new InputStreamReader(stream));
    }

    String next() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }
}