import java.io.*;
import java.util.*;

public class alley_av {

	FastScanner in;
	PrintWriter out;

	void solve() {
		int n = in.nextInt(), m = in.nextInt(), length = in.nextInt();
		int[] trees = new int[n];
		for (int i = 0; i < n; i++) {
			trees[i] = in.nextInt();
		}
		Query[] qs = new Query[m];
		for (int i = 0; i < m; i++) {
			qs[i] = new Query(in.nextInt(), i);
		}
		Arrays.sort(qs);

		Map<Integer, Integer> count = new HashMap<>();
		for (int i = 0; i < n - 1; i++) {
			int dist = trees[i + 1] - trees[i];
			if (!count.containsKey(dist)) {
				count.put(dist, 0);
			}
			count.put(dist, count.get(dist) + 1);
		}

		PriorityQueue<Segment> heap = new PriorityQueue<>();
		for (Map.Entry<Integer, Integer> entry : count.entrySet()) {
			Segment s = new Segment(entry.getKey(), entry.getKey(),
					entry.getValue());
			if (entry.getKey() > 1) {
				heap.add(s);
			}
		}

		int[] ans = new int[m];
		int ptr = 0;
		int curAnswer = 0;
		while (ptr < m && heap.size() > 0) {
			Segment cur = heap.poll();
			int nextTrees = cur.next();

			int nextAnswer = curAnswer + (nextTrees - cur.curTrees) * cur.count;
			while (ptr < m && qs[ptr].value < nextAnswer) {
				ans[qs[ptr].idx] = cur.curAns;
				ptr++;
			}

			cur.curAns = (cur.length + nextTrees) / (nextTrees + 1);
			cur.curTrees = nextTrees;
			curAnswer = nextAnswer;
			if (cur.curAns > 1) {
				heap.add(cur);
			}
		}

		while (ptr < m) {
			ans[qs[ptr++].idx] = 1;
		}
		for (int i = 0; i < m; i++) {
			out.println(ans[i]);
		}
	}

	class Query implements Comparable<Query> {
		int value, idx;

		public Query(int value, int idx) {
			super();
			this.value = value;
			this.idx = idx;
		}

		@Override
		public int compareTo(Query o) {
			return Integer.compare(value, o.value);
		}
	}

	class Segment implements Comparable<Segment> {
		int curAns;
		int length;
		int count;
		int curTrees;

		public Segment(int curAns, int length, int count) {
			super();
			this.curAns = curAns;
			this.length = length;
			this.count = count;
			this.curTrees = 0;
		}

		int next() {
			if (length % (curAns - 1) == 0) {
				return length / (curAns - 1) - 1;
			} else {
				return length / (curAns - 1);
			}
		}
		
		@Override
		public String toString() {
			return "Segment [curAns=" + curAns + ", length=" + length
					+ ", count=" + count + ", curTrees=" + curTrees + "]";
		}

		@Override
		public int compareTo(Segment o) {
			return -Integer.compare(curAns, o.curAns);
		}

	}

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String nextToken() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(nextToken());
		}

		long nextLong() {
			return Long.parseLong(nextToken());
		}

		double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new alley_av().run();
	}
}
