import java.io.*;
import java.util.*;

public class alley_bm {
    FastScanner in;
    PrintWriter out;

    class Diff implements Comparable<Diff> {
        int pos;
        int diff;

        public Diff(int pos, int diff) {
            super();
            this.pos = pos;
            this.diff = diff;
        }

        @Override
        public int compareTo(Diff o) {
            return Integer.compare(pos, o.pos);
        }

    }

    void solve(int[] lengths, int[] queries) {
        final int MAX = (int) 1e6;
        int[] diff = new int[MAX];
        ArrayList<Diff> bigDiffs = new ArrayList<>();
        for (int len : lengths) {
            int ans = 1;
            int cost = len - 1;
            int prevCost = 0;
            while (true) {
                if (ans < MAX) {
                    diff[ans] += cost - prevCost;
                } else {
                    bigDiffs.add(new Diff(ans, cost - prevCost));
                }
                if (cost == 0) {
                    break;
                }
                int nAns = 1 + (len - 1) / cost;
                int nCost = (len - 1) / nAns;
                prevCost = cost;
                cost = nCost;
                ans = nAns;
            }
        }
        Collections.sort(bigDiffs);
        ArrayList<Function> f = new ArrayList<>();
        Function last = new Function(0, 0);
        for (int ans = 1; ans < MAX; ans++) {
            if (diff[ans] != 0) {
                Function newOne = new Function(ans, last.need + diff[ans]);
                f.add(newOne);
                last = newOne;
            }
        }
        for (int i = 0; i < bigDiffs.size();) {
            int j = i;
            int curDiff = 0;
            while (j != bigDiffs.size()
                    && bigDiffs.get(j).pos == 0 + bigDiffs.get(i).pos) {
                curDiff += bigDiffs.get(j).diff;
                j++;
            }
            Function newOne = new Function(bigDiffs.get(i).pos, last.need
                    + curDiff);
            f.add(newOne);
            last = newOne;
            i = j;
        }
        for (int qq : queries) {
            int left = -1, right = f.size() - 1;
            while (right - left > 1) {
                int mid = (left + right) >>> 1;
                if (f.get(mid).need <= qq) {
                    right = mid;
                } else {
                    left = mid;
                }
            }
            int answer = f.get(right).ans;
            out.println(answer);
        }
    }

    class Function {
        int ans;
        int need;

        public Function(int ans, int need) {
            super();
            this.ans = ans;
            this.need = need;
        }

    }

    void solve() {
        int n = in.nextInt();
        int m = in.nextInt();
        in.nextInt();
        int[] lengths = new int[n - 1];
        int last = in.nextInt();
        for (int i = 0; i < n - 1; i++) {
            int cur = in.nextInt();
            lengths[i] = cur - last;
            last = cur;
        }
        int[] q = new int[m];
        for (int i = 0; i < m; i++) {
            q[i] = in.nextInt();
        }
        solve(lengths, q);
    }

    void run() {
        try {
            in = new FastScanner(new File("tests/10"));
            out = new PrintWriter(new File("E.out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    void runIO() {

        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        public FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        boolean hasMoreTokens() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return false;
                st = new StringTokenizer(s);
            }
            return true;
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }
    }

    public static void main(String[] args) {
        new alley_bm().runIO();
    }
}