import java.io.*;
import java.util.*;

public class stage_av {

	FastScanner in;
	PrintWriter out;

	int Z;

	class QueueDP {
		int n, k;
		StackDP stack1, stack2;

		public QueueDP(int n, int k) {
			stack1 = new StackDP(n, k);
			stack2 = new StackDP(n, k);
			this.n = n;
			this.k = k;
		}

		boolean isGoodValue() {
			int[] array1 = stack1.stack[stack1.size - 1];
			int[] array2 = stack2.stack[stack2.size - 1];
			
			for (int mask = 0; mask < 1 << k; mask++) {
				if (array1[mask] + array2[(1 << k) - 1 - mask] >= Z) {
					return true;
				}
			}
			return false;
		}

		void push(int mask, int p) {
			stack2.push(mask, p);
		}

		void pop() {
			if (stack1.isEmpty()) {
				while (!stack2.isEmpty()) {
					stack1.push(stack2.mask[stack2.size - 1],
							stack2.power[stack2.size - 1]);
					stack2.pop();
				}
			}
			stack1.pop();
		}

	}

	class StackDP {
		int k, size;
		int[][] stack;
		int[] mask, power;

		public StackDP(int n, int k) {
			stack = new int[n + 1][1 << k];
			mask = new int[n + 1];
			power = new int[n + 1];
			size = 1;
			this.k = k;
		}

		boolean isEmpty() {
			return size == 1;
		}

		public int getValue(int mask) {
			return stack[size - 1][mask];
		}

		public void push(int mask, int p) {
			for (int i = 0; i < 1 << k; i++) {
				stack[size][i] = stack[size - 1][i];
				if ((i & mask) == mask
						&& stack[size - 1][i ^ mask] + p > stack[size][i]) {
					stack[size][i] = stack[size - 1][i ^ mask] + p;
					if (stack[size][i] >= Z) {
						stack[size][i] = Z;
					}
				}
			}
			this.mask[size] = mask;
			this.power[size] = p;
			size++;
		}

		public void pop() {
			size--;
		}
	}

	void solve() {
		int n = in.nextInt(), k = in.nextInt();
		this.Z = in.nextInt();

		int[] p = new int[n], mask = new int[n];
		for (int i = 0; i < n; i++) {
			p[i] = in.nextInt();
		}
		for (int i = 0; i < n; i++) {
			int ki = in.nextInt();
			for (int j = 0; j < ki; j++) {
				mask[i] |= 1 << (in.nextInt() - 1);
			}
		}

		QueueDP q = new QueueDP(n, k);

		int r = 0;
		for (int i = 0; i < n; i++) {
			while (r < n && !q.isGoodValue()) {
				q.push(mask[r], p[r]);
				r++;
			}
			if (q.isGoodValue()) {
				out.println(r);
			} else {
				out.println(-1);
			}
			q.pop();
		}
	}

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String nextToken() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(nextToken());
		}

		long nextLong() {
			return Long.parseLong(nextToken());
		}

		double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new stage_av().run();
	}
}
