import java.io.*;
import java.util.*;

public class stage_bm_dq {
	FastScanner in;
	PrintWriter out;

	int[] answer;
	int n, k, Z;
	int[] p;
	int[] zero;
	int[][] value;
	int[] mask;
	int sz;

	void add(int[] was, int[] next, int mask, int value) {
		for (int i = 0; i < sz; i++) {
			next[i] = was[i];
		}
		for (int i = 0; i < sz; i++) {
			if ((i & mask) != 0) {
				continue;
			}
			int go = was[i] + value;
			if (go > Z) {
				go = Z;
			}
			if (next[i ^ mask] < go) {
				next[i ^ mask] = go;
			}
		}
	}

	boolean ok(int[] a, int[] b) {
		for (int i = 0; i < sz; i++) {
			if (a[i] + b[(sz - 1) ^ i] >= Z) {
				return true;
			}
		}
		return false;
	}

	void go(int l, int r, int alreadyKnowFrom) {
		if (alreadyKnowFrom <= l) {
			return;
		}
		if (l == r) {
			if (p[l] >= Z) {
				answer[l] = l;
			}
			return;
		}
		int m = (l + r) >>> 1;
		int[] cur = zero;
		int lastNotOk = m + 1;
		for (int i = m; i >= l; i--) {
			add(cur, value[i], mask[i], p[i]);
			cur = value[i];
			if (cur[cur.length - 1] >= Z) {
				break;
			}
			lastNotOk = i;
		}
		int curR = m + 1;
		int goTo = Math.min(m, alreadyKnowFrom - 1);
		cur = zero;
		add(cur, value[curR], mask[curR], p[curR]);
		for (int i = lastNotOk; i <= goTo; i++) {
			if (ok(value[i], value[curR])) {
				answer[i] = curR;
			} else {
				boolean ok = false;
				while (true) {
					curR++;
					if (curR > r) {
						break;
					}
					add(value[curR - 1], value[curR], mask[curR], p[curR]);
					if (ok(value[i], value[curR])) {
						ok = true;
						break;
					}
				}
				if (ok) {
					answer[i] = curR;
				} else {
					break;
				}
			}
		}
		go(l, m, lastNotOk);
		go(m + 1, r, alreadyKnowFrom);
	}

	void solve() {
		n = in.nextInt();
		k = in.nextInt();
		sz = 1 << k;
		Z = in.nextInt();
		p = new int[n];
		for (int i = 0; i < n; i++) {
			p[i] = in.nextInt();
		}
		mask = new int[n];
		for (int i = 0; i < n; i++) {
			int cnt = in.nextInt();
			for (int j = 0; j < cnt; j++) {
				mask[i] ^= 1 << (in.nextInt() - 1);
			}
		}
		zero = new int[1 << k];
		value = new int[n][1 << k];
		if (Z == 0) {
			for (int i = 0; i < n; i++) {
				out.println(i + 1);
			}
			return;
		}
		answer = new int[n];
		Arrays.fill(answer, -1);
		go(0, n - 1, n);
		for (int ans : answer) {
			out.println(ans < 0 ? ans : ans + 1);
		}
	}

	void run() {
		try {
			in = new FastScanner(new File("stage.in"));
			out = new PrintWriter(new File("stage.out"));

			solve();

			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	void runIO() {

		in = new FastScanner(System.in);
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		public FastScanner(InputStream f) {
			br = new BufferedReader(new InputStreamReader(f));
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return null;
				st = new StringTokenizer(s);
			}
			return st.nextToken();
		}

		boolean hasMoreTokens() {
			while (st == null || !st.hasMoreTokens()) {
				String s = null;
				try {
					s = br.readLine();
				} catch (IOException e) {
					e.printStackTrace();
				}
				if (s == null)
					return false;
				st = new StringTokenizer(s);
			}
			return true;
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new stage_bm_dq().runIO();
	}
}