#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1 << 17;
const int inf = 1e9 + 7;

struct Stack {
    vector<pair<int, int> > v;

    Stack() {}

    int mx() {
        return v.empty() ? -inf : v.back().second;
    }

    void push(int x) {
        v.push_back(make_pair(x, max(mx(), x)));
    }

    int pop() {
        int res = v.back().first;
        v.pop_back();
        return res;
    }

    bool empty() {
        return v.empty();
    }
};

struct Queue {
    Stack s1, s2;

    Queue() {}

    int mx() {
        return max(s1.mx(), s2.mx());
    }

    void push(int x) {
        s2.push(x);
    }

    void pop() {
        if (s1.empty()) {
            while (!s2.empty()) {
                s1.push(s2.pop());
            }
        }
        s1.pop();
    }
};

int n, k, z;
int p[MAXN];
int mask[MAXN];
vector<int> a[MAXN];
Queue q[MAXN];
int ans[MAXN];

bool rec(int mask, int cur) {
    if (cur >= z) return 1;

    int can = ((1 << k) - 1) ^ mask;
    for (int m = can; m; m = (m - 1) & can) {
        int value = q[m].mx();
        if (value == -inf) continue;
        if (rec(mask | m, cur + value)) return 1;
    }
    return 0;
}

bool ok() {
    return rec(0, 0);
}

int main() {
    scanf("%d%d%d", &n, &k, &z);
    for (int i = 0; i < n; i++) scanf("%d", &p[i]);
    for (int i = 0; i < n; i++) {
        int k;
        scanf("%d", &k);
        a[i].resize(k);
        mask[i] = 0;
        for (int j = 0; j < k; j++) scanf("%d", &a[i][j]), mask[i] |= 1 << (--a[i][j]);
    }

    int l = -1, r = 0;
    for (l = 0; l < n; l++) {
        bool f = ok();
        while (r < n && !f) {
            q[mask[r]].push(p[r]);
            r++;
            f = ok();
        }
        if (!f) r = n + 1;

        ans[l] = r;
        q[mask[l]].pop();
    }
    for (int i = 0; i < n; i++) printf("%d\n", ans[i] == n + 1 ? -1 : ans[i]);
   
    return 0;
}